#
# Conditional build:
%bcond_without	doc	# API documentation
%bcond_without	tests	# unit tests

%define		module	frozenlist
Summary:	A list-like structure which implements collections.abc.MutableSequence
Summary(pl.UTF-8):	Podobna do listy struktura implementująca collections.abc.MutableSequence
Name:		python3-%{module}
Version:	1.5.1
Release:	1
License:	Apache v2.0
Group:		Libraries/Python
#Source0Download: https://pypi.org/simple/frozenlist/
# Source0:	https://files.pythonhosted.org/packages/source/f/frozenlist/%{module}-%{version}.tar.gz
Source0:	https://github.com/aio-libs/frozenlist/archive/57ce23807c0d08651106c9de0b78e525838f3fac.zip
# Source0-md5:	1b50afd47f8eb56e34efdde796207b2b
Patch0:		disable-towncrier.patch
URL:		https://pypi.org/project/frozenlist/
BuildRequires:	python3-Cython >= 3.0.12
BuildRequires:	python3-build
BuildRequires:	python3-devel >= 1:3.8
BuildRequires:	python3-expandvars
BuildRequires:	python3-installer
BuildRequires:	python3-setuptools >= 1:47
%if %{_ver_lt "%py3_ver" 3.11}
BuildRequires:	python3-tomli
%endif
BuildRequires:	rpm-build >= 4.6
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 2.044
%if %{with doc}
BuildRequires:	python3-aiohttp_theme
BuildRequires:	sphinx-pdg-3
%endif
Requires:	python3-modules >= 1:3.8
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
frozenlist.FrozenList is a list-like structure which implements
collections.abc.MutableSequence. The list is mutable until
FrozenList.freeze is called, after which list modifications
raise RuntimeError.

%description -l pl.UTF-8
frozenlist.FrozenList to podobna do listy struktura implementująca
collections.abc.MutableSequence. Lista jest modyfikowalna do czasu
wywołania FrozenList.freeze, po którym próby modyfikacji rzucą
wyjątek RuntimeError.

%package apidocs
Summary:	API documentation for Python %{module} module
Summary(pl.UTF-8):	Dokumentacja API modułu Pythona %{module}
Group:		Documentation
BuildArch:	noarch

%description apidocs
API documentation for Python %{module} module.

%description apidocs -l pl.UTF-8
Dokumentacja API modułu Pythona %{module}.

%prep
#%%setup -q -n %{module}-%{version}
%setup -q -n %{module}-57ce23807c0d08651106c9de0b78e525838f3fac
%patch -P0 -p1

# keep *.c files so debuginfo will pick it up
sed -i -e 's#build_inplace: bool = False,#build_inplace: bool = True,#g' -e 's#build_inplace=False#build_inplace=True#g' packaging/pep517_backend/_backend.py

%build
%py3_build_pyproject

%if %{with tests}
PYTEST_DISABLE_PLUGIN_AUTOLOAD=1 \
%{__python3} -m pytest tests
%endif

%if %{with doc}
%{__make} -C docs html \
	SPHINXBUILD=sphinx-build-3
%endif

%install
rm -rf $RPM_BUILD_ROOT

%py3_install_pyproject

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc CHANGES.rst CONTRIBUTORS.txt README.rst
%dir %{py3_sitedir}/%{module}
%{py3_sitedir}/%{module}/*.py
%{py3_sitedir}/%{module}/*.pyi
%{py3_sitedir}/%{module}/*.pyx
%{py3_sitedir}/%{module}/py.typed
%attr(755,root,root) %{py3_sitedir}/%{module}/*.so
%{py3_sitedir}/%{module}/__pycache__
%{py3_sitedir}/%{module}-%{version}*.dist-info

%if %{with doc}
%files apidocs
%defattr(644,root,root,755)
%doc docs/_build/html/{_static,*.html,*.js}
%endif
%changelog
* Tue Apr 08 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python3-frozenlist.git;a=log;h=auto/th/python3-frozenlist-1.5.1-1

* Tue Apr 08 2025 Arkadiusz Miśkiewicz <arekm@maven.pl> 4b1cd16
- Use 1.5.1 dev version (git snap) for now (until there is a release with python 3.13 support)

* Wed Mar 19 2025 Jan Palus <atler@pld-linux.org> aa6b687
- noarch apidocs

* Wed Mar 19 2025 Jan Palus <atler@pld-linux.org> 353ddc9
- up to 1.5.0

* Tue Mar 11 2025 Jan Rękorajski <baggins@pld-linux.org> 71c1af5
- doc/test rebuild for python 3.13

* Mon Mar 10 2025 Jan Rękorajski <baggins@pld-linux.org> 0f072dd
- python 3.13 rebuild

* Tue Feb 28 2023 Jan Palus <atler@pld-linux.org> 5736624
- up to 1.3.3

* Sat Sep 10 2022 Jakub Bogusz <qboosh@pld-linux.org> 6ae2166
- updated to 1.3.1

* Wed Mar 30 2022 Jan Rękorajski <baggins@pld-linux.org> 775dc63
- rebuild with tests and docs

* Fri Mar 25 2022 Jan Rękorajski <baggins@pld-linux.org> b230e9e
- rebuild with python 3.10

* Fri Mar 25 2022 Jan Rękorajski <baggins@pld-linux.org> c99e6f6
- rebuild with python 3.10

* Sat Mar 19 2022 Jakub Bogusz <qboosh@pld-linux.org> ae2a108
- updated to 1.3.0

* Sun Nov 28 2021 Jan Rękorajski <baggins@pld-linux.org> fb092be
- new

